unit UDes;
{Collatinus - Extraction du lexique d'un texte latin.

Copyright (C) 1998 Y. Ouvrard.

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le
modifier conformment aux dispositions de la Licence Publique Gnrale GNU,
telle que publie par la Free Software Foundation ; version 2 de la licence,
ou encore ( votre choix) toute version ultrieure.
Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE
GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou D'ADAPTATION
A UN OBJET PARTICULIER.
Pour plus de dtail, voir la Licence Publique Gnrale GNU .
Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la
Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
Pour tout contact avec les auteurs : zarlino@iname.com }

{
   faire
     . une procdure de nettoyage de la base de dsinences :
       modle absent, dfinitions non pertinentes ou incompltes.
     . enregistrer le lexique aprs modif des dsinences.

}

interface
Uses Classes;

Type
  TDef = Class(TObject)
    Modele,
    RadicalNumero : integer;
    Flags : integer;
    Constructor Create(M, RN, Fl : integer);
      // Modle, RadicalNumro, Flags
    Constructor Lis(R : TReader);
    Procedure Ecris(W : TWriter);
    private
     Function GetCategorie : integer;
     Function GetCasus : integer;
     Function GetGenus : integer;
     Function GetNumerus : integer;
     Function GetModus : integer;
     Function GetTempus : integer;
     Function GetPersona : integer;
     Function GetVox : integer;
     Function GetGradus : integer;
    procedure SetCasus(const Value: integer);
    procedure SetGenus(const Value: integer);
    procedure SetGradus(const Value: integer);
    procedure SetModus(const Value: integer);
    procedure SetNumerus(const Value: integer);
    procedure SetPersona(const Value: integer);
    procedure SetTempus(const Value: integer);
    procedure SetVox(const Value: integer);
    public
     property Categorie : integer read GetCategorie;
     property Casus : integer read GetCasus write SetCasus;
     property Genus: integer read GetGenus write SetGenus;
     property Numerus: integer read GetNumerus write SetNumerus;
     property Modus: integer read GetModus write SetModus;
     property Tempus: integer read GetTempus write SetTempus;
     property Persona: integer read GetPersona write SetPersona;
     property Vox: integer read GetVox write SetVox;
     property Gradus: integer read GetGradus write SetGradus;
     Function Graphie ( Complete : Boolean) : string;
    end;

  TListeDes = Class(TStringList)
  private
    function Getgraphie(LeModele, G, M, T, V, D : integer): TstringList;
    procedure Setgraphie(LeModele, G, M, T, V, D : integer;
      const Value: TstringList);
  public
    Constructor Lis(R : TReader);
    Procedure Ecris(W : TWriter);
    Procedure EcrisListe(N : integer ; W : TWriter);
    Procedure Ajoute(
      D : string ;
      M, RN, Fl : integer);
    Function Definitions(N : integer) : TList;
    Function Definition(N, D : integer) : TDef;
    property graphie[LeModele, G, M, T, V, D : integer]: TstringList
       read Getgraphie write Setgraphie;
  end;

Const

// noms

  // Cas
  Cas : array[0..5] of integer = ($01, $02, $04, $08, $10, $20);
  totalCas = ($01 or $02 or $04 or $08 or $10 or $20);

  // Nombres
  Nombres : Array[0..1] of integer = ($40, $80);
  totalNombres = ($40 or $80);

  // Genres
  Genres : Array[0..2] of integer = ($100, $200, $400);
  totalGenres = ($100 or $200 or $400);

  // personnes
  Personnes : Array[0..2] of integer =
    ($800, $1000, $2000);
  TotalPersonnes = ($800 or $1000 or $2000);

  // temps
  Temps : Array[0..5] of integer =
    ($4000, $8000, $10000, $20000, $40000, $80000);
  totalTemps =
  ($4000 or $8000 or $10000 or $20000 or $40000 or $80000);


  // modes
  Modes : Array[0..6] of integer =
    ($100000, $200000, $400000, $800000, $1000000, $2000000, $4000000);
  TotalModes =
    ($100000 or $200000 or $400000 or $800000 or $1000000 or $2000000 or $4000000);

  // voix
  Voix : Array[0..1] of integer = ($8000000, $10000000);
  TotalVoix = ($8000000 or $10000000);

  // degr (ajout en novembre mmi)
  Degres : Array[0..2] of cardinal = ($20000000, $40000000, $80000000);
  TotalDegres = $20000000 or $40000000 or $80000000;

var
  Desinences : TListeDes;

implementation
uses SysUtils, Ulistes, Utiles, Token;

{ TDef }

Constructor TDef.Create(M, RN, Fl : integer);
Begin
Inherited Create;
Modele := M;
RadicalNumero := RN ;
Flags := Fl;
end;

Constructor TDef.Lis(R : TReader);
Begin
Modele := R.ReadInteger;
RadicalNumero := R.ReadInteger;
Flags := R.ReadInteger;
end;

Procedure TDef.Ecris(W : TWriter);
Begin
W.WriteInteger(Modele);
W.WriteInteger(RadicalNumero);
W.WriteInteger(Flags);
end;

Function TDef.GetCategorie : integer;
Begin
Case Modele of
    0..10 : result := 0 ; // nom
    11..16 : result := 1 ;// adj
    17..28 : result := 3; // verbe
    29 : result := 2 ;  // pronom
    30 : result := 4 ; // inv.
    else result := -1;
    end;
end;

Function TDef.GetCasus : integer;
var i : integer;
Begin
result := -1;
for i := 0 to 5 do
  if Flags and cas[i] > 0
  then
  if result = -1 then result := i
    else result := result or i;
end;

Function TDef.GetGenus : integer;
var i : integer;
Begin
result := -1;
for i := 0 to 2 do
  if Flags and Genres[i] > 0
  then result := i;
end;

Function TDef.GetNumerus : integer;
var i : integer;
Begin
result := -1;
for i := 0 to 1 do
  if Flags and Nombres[i] > 0
  then result := i;
end;

Function TDef.GetModus : integer;
var i : integer;
Begin
result := -1;
for i := 0 to 6 do
  if Flags and Modes[i] > 0
  then result := i;
end;

Function TDef.GetTempus : integer;
var i : integer;
Begin
result := -1;
for i := 0 to 5 do
  if Flags and Temps[i] > 0
  then result := i;
end;

Function TDef.GetPersona : integer;
var i : integer;
Begin
result := -1;
for i := 0 to 2 do
  if Flags and Personnes[i] > 0
  then result := i;
end;


Function TDef.GetVox : integer;
var i : integer;
Begin
result := -1;
for i := 0 to 1 do
  if Flags and Voix[i] > 0
  then result := i;
end;

Function TDef.Graphie ( Complete : Boolean) : String;
var i : integer;
Begin
Result := '';
// personne
for i := 0 to 2 do
  if Flags and personnes[i] > 0
  then result := result + ' '+listePersonnes[i];
// cas
for i := 0 to 5 do
  if Flags and cas[i] > 0
  then result := listeCas[i];
// genre
For i := 0 to 2 do
  if Flags and Genres[i] > 0
  then result := result+' '+ListeGenres[i];
// nombre
for i := 0 to 1 do
  if Flags and nombres[i] > 0
  then result := result+' '+listeNombres[i];
// mode
for i := 0 to 6 do
  if flags and modes[i] > 0
  then result := result+' '+listeModes[i];
// temps
for i := 0 to 5 do
  if flags and temps[i] > 0
  then result := result+' '+listeTemps[i];
// voix
for i := 0 to 1 do
  if flags and voix[i] > 0
  then result := result + ' ' + listeVoix[i];
// degr
for i := 0 to 2 do
   if flags and degres[i] > 0
      then result := result + ' ' + ListeDegres[i];
// modle et radical
if Complete then
  result := result + ' modle '+ListeModeles[modele]+
                   ' radical '+inttoStr(radicalNumero);
end;

function TDef.GetGradus: integer;
   var i : integer;
begin
   Result :=  -1;
   for i := 0 to 2 do
     if Flags and Degres[i] > 0
     then result := i;
end;

procedure TDef.SetCasus(const Value: integer);
begin
   Flags := Flags and not TotalCas;
   Flags := Flags or Value;
end;

procedure TDef.SetGenus(const Value: integer);
begin
   Flags := Flags and not TotalGenres; 
   Flags := Flags or Value;
end;

procedure TDef.SetGradus(const Value: integer);
begin
   Flags := Flags and not TotalDegres;
   Flags := Flags or Value;
end;

procedure TDef.SetModus(const Value: integer);
begin
   Flags := Flags and not TotalModes;
   Flags := Flags or Value;
end;

procedure TDef.SetNumerus(const Value: integer);
begin
   Flags := Flags and not TotalNombres;
   Flags := Flags or Value;
end;

procedure TDef.SetPersona(const Value: integer);
begin
   Flags := Flags and not TotalPersonnes;
   Flags := Flags or Value;
end;

procedure TDef.SetTempus(const Value: integer);
begin                      
   Flags := Flags and not TotalTemps;
   Flags := Flags or Value;
end;

procedure TDef.SetVox(const Value: integer);
begin 
   Flags := Flags and not TotalVoix;
   Flags := Flags or Value;
end;

{ TListeDes }
 
Constructor TListeDes.Lis(R : TReader);
var i, idef  : integer;
    l : TList;
    ChDes : String;
Begin
inherited Create;
Sorted := true;
Duplicates := dupError;
// lecture;
i := R.ReadInteger;
While i > 0 do
  begin
  ChDes := R.ReadString;
  l := TList.Create;
  idef := R.ReadInteger;
  while idef > 0 do
    begin
    l.Add(TDef.lis(R));
    dec(idef);
    end;
  AddObject(ChDes, l);
  dec(i);
  end;
end;

Procedure TListeDes.Ecris(W : TWriter);
var i : integer;
Begin
W.WriteInteger(Count);
For i := 0 to count-1 do EcrisListe(i, W);
end;


Procedure TListeDes.EcrisListe(N : integer ; W : TWriter);
var i : integer;
Begin
W.WriteString(Strings[N]);
W.WriteInteger(Definitions(N).count);
for i := 0 to Definitions(N).count-1 do
  Definition(N, i).Ecris(W);
end;

Function TListeDes.Definitions(N : integer) : TList;
Begin
Result := TList(Objects[N]);
end;


Function TListeDes.Definition(N, D : integer) : TDef;
Begin
Result := TDef(Definitions(N)[D]);
end;

Procedure TListeDes.Ajoute(
  D : string ;
  M, RN, Fl : integer);
var p, i : integer;
    l : TList;
Begin
if not Find(D, p) then
// p := indexOf(D);
// if p < 0 then
  begin
  l := TList.Create;
  l.add(TDef.Create(M, RN, Fl));
  addObject(D, l);
  end
  else
  begin
  For i := 0 to definitions(p).count -1 do
    if (Definition(p, i).Flags = Fl) and
       (Definition(p, i).modele = M) and
       (Definition(p, i).radicalNumero = RN) then exit;
  TList(Objects[p]).Add(TDef.Create(M, RN, Fl));
  end;
end;

function TListeDes.Getgraphie(LeModele, G, M, T, V, D : integer): TstringList;
  var iDes, iDef, max : integer;
  function ajoute(l : string; d : string) : string;
  begin
  if (l = '-')
     then result := d
     else result := l + ',' + d;
  end;
begin
   { renvoie la dsinence de modle, cas, genre, nombre, mode, temps,
     voix et degr demands }
result := TStringList.Create;
// calculer la longueur de la liste
max := 0;
Case LeModele of
   0..16 : max := 11; // noms et adj.
   17..28 :
      case M of
        0..2, 5 : max := 5;
        3 : max := 0;
        else max := 11;
        end;
   end;
for iDes := 0 to max do result.Add('-');
for iDes := 0 to count - 1 do
   for iDef := 0 to Definitions(iDes).Count - 1 do
      with Definition(iDes, iDef) do
         if (modele = LeModele) and (Genus = G) and (Tempus = T)
            and (Modus = M) and (Vox = V) and (Gradus = D)
            then case categorie of
               0, 1 : // nom, adjectif
                  result[casus + (numerus * 6)] :=
                  ajoute (result[casus + (numerus * 6)], rebours(strings[iDes]));
               3 : // verbe
                  case M of
                     0..2 : result[persona + (numerus * 3)] :=
                        ajoute(result[persona + (numerus * 3)], rebours(strings[iDes]));
                     3 : result[0] :=
                        ajoute(result[0], rebours(strings[iDes])); // infinitif
                     4.. 6 :
                        result[casus + (numerus * 6)] :=
                        ajoute (result[casus + (numerus * 6)], rebours(strings[iDes]));
                     end;
               end;
end;

procedure TListeDes.Setgraphie(LeModele, G, M, T, V, D : integer;
      const Value: TstringList);
var
   iDes, iDef, iLigne, iAtome, R : integer;
                            // R = radical numro...
   function verif(l : string) : string;
   begin
   result := trim(l);
   if l[1] = '-'
      then result := '';
   end;
begin
// lit les dsinences et les intgre  la base.
// 1. supprimer de la base toutes les dfinitions correspondant  la morpho
for iDes := 0 to count - 1 do
   begin
       iDef := 0;
       while iDef < Definitions(iDes).count do
          with Definition(iDes, iDef) do
             if (modele = LeModele)
                and (genus = G)
                and (modus = M)
                and (tempus = T)
                and (vox = V)
                and (gradus = D)
                then Definitions(iDes).Delete(iDef)
                else inc(iDef);
   end;
// 2. ajouter les dfinitions de Value en tenant compte des ds. multiples.
case leModele of
   0..10 : // nom
      for iLigne := 0 to 11 do
         begin
           Value[iLigne] := verif(Value[iLigne]);
           if (Value[iLigne] > '') then
               begin
                  for iAtome := 1 to NumToken(Value[iLigne], ',') do
                     begin
                        Ajoute(
                          rebours(trim(GetToken(Value[iLigne], ',', iAtome))),
                          leModele,
                          1, // numro de radical
                          cas[iLigne mod 6]   // sing/plur !
                            or nombres[iLigne div 6]
                          );
                     end;
               end;
         end;
   11..16 : // adjectif : + genre + degr
      for iLigne := 0 to 11 do
         begin
           Value[iLigne] := verif(Value[iLigne]);
           if (Value[iLigne] > '') then
               begin
                  for iAtome := 1 to NumToken(Value[iLigne], ',') do
                     begin
                        Ajoute(
                          rebours(trim(GetToken(Value[iLigne], ',', iAtome))),
                          leModele,
                          1, // numro de radical
                          cas[iLigne mod 6]   // sing/plur !
                            or nombres[iLigne div 6]
                            or genres[G]
                            or degres[D]
                          );
                     end;
               end;
         end;
   17..28 : // verbe : tenir compte des formes dclines
      case M of
         0..2 : // modes conjugus.
            begin
              // radical
              if T < 3
                 then R := 1   // infectum
                 else R := 2;  // perfectum
              for iLigne := 0 to 5 do
                 begin
                    Value[iLigne] := verif(Value[iLigne]);
                    if (Value[iLigne] > '') then
                       for iAtome := 1 to NumToken(Value[iLigne], ',') do
                          Ajoute(
                             rebours(trim(GetToken(Value[iLigne], ',', iAtome))),
                             leModele,
                             R, // numro de radical
                             personnes[iLigne mod 3]   // sing/plur !
                               or nombres[iLigne div 3]
                               or temps[T]
                               or modes[M]
                               or Voix[V]);
                 end;
            end;
         3 : // infinitif
            begin
              Value[0] := verif(Value[0]);
              case T of
                 0 : R := 1;  // prsent
                 3 : R := 2; // parfait
                 else R := 3; // futur
                 end;
              for iAtome := 1 to NumToken(Value[0], ',') do
                 Ajoute(
                     rebours(trim(GetToken(Value[0], ',', iAtome))),
                        leModele,
                        R, // numro de radical
                        temps[T]
                          or modes[M]
                          or Voix[V]);
            end;
         4, 6 : // modes dclins
            begin
                case T of
                   0 : R := 1;  // prsent
                   3 : R := 2; // parfait
                   else R := 3; // futur
                   end;
                for iLigne := 0 to 11 do
                   begin
                     Value[iLigne] := verif(Value[iLigne]);
                     if (Value[iLigne] > '') then
                         begin
                            for iAtome := 1 to NumToken(Value[iLigne], ',') do
                               begin
                                  Ajoute(
                                    rebours(trim(GetToken(Value[iLigne], ',', iAtome))),
                                    leModele,
                                    R, // numro de radical
                                    cas[iLigne mod 6]   // sing/plur !
                                      or nombres[iLigne div 6]
                                      or genres[G]
                                      or modes[M]
                                      or temps[T]
                                      or voix[V]
                                    );
                               end;
                         end;
                 end;
             end;
         5 : // grondif
            for iLigne := 0 to 5 do
               begin
                  Value[iLigne] := verif(Value[iLigne]);
                  if (Value[iLigne] > '') then
                     for iAtome := 1 to NumToken(Value[iLigne], ',') do
                        Ajoute(
                           rebours(trim(GetToken(Value[iLigne], ',', iAtome))),
                           leModele,
                           1, // numro de radical
                           cas[iLigne mod 6]
                           or modes[M]);
               end;
         end;
      end;
end;

end.
