unit UIrreg;
{Collatinus - Extraction du lexique d'un texte latin.

Copyright (C) 1998 Y. Ouvrard.

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le
modifier conformment aux dispositions de la Licence Publique Gnrale GNU,
telle que publie par la Free Software Foundation ; version 2 de la licence,
ou encore ( votre choix) toute version ultrieure.
Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE
GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou D'ADAPTATION
A UN OBJET PARTICULIER.
Pour plus de dtail, voir la Licence Publique Gnrale GNU .
Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la
Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
Pour tout contact avec les auteurs : zarlino@iname.com}

interface

uses
  SysUtils, Classes, UDes;

type

  TDonneesIrreg = Class(TDef)
    Canon : string;
    Constructor Create(F, M : integer ; K : String);
    end;

  TListeIrreg = class(TStringList)
    Constructor Lis(R : TReader);
    Procedure Ecris(W : TWriter);
    Procedure Ajoute(C, K : String ; F, M : integer);
    {C : forme irrgulire; K : Canon; F : Flags; M : modle (!)}
    Function Definitions(N : integer) : TList;
    Function Definition(N, D : integer) : TDonneesIrreg;
    {GraphieFNum renvoie la graphie de l'irrgulier de canon K et de rang Num}
    function GraphieFNum(K : string; Num : integer) : string;
    {DefKNum renvoie la morpho de l'irrg de canon K et de rang Num dans la base}
    function DefKNum(K : string; Num : integer) : TDonneesIrreg;
    { conmme DefKNum, mais avec destruction }
    Procedure DeleteKF(K : string; F : integer);
    Procedure IrregsK(K : string; L : TStrings);
    end;

var
  Irregs : TListeIrreg;

implementation

uses Ulex, UListes;

//|||||||||||||||||||||||
// TDonneesIrreg ||||||||
//|||||||||||||||||||||||

Constructor TDonneesIrreg.Create(F, M : integer ; K : String);
// F : flags; M : Modle; K : Canon
Begin
inherited Create(0,0,F);
{TDef.Create(M, RN, Fl : integer);}
Modele := M;
Canon := K;
end;

//|||||||||||||||||||||
// TListeIrreg ||||||||
//|||||||||||||||||||||


Constructor TListeIrreg.Lis(R : TReader);
var i, iliste, f : integer;
    FIrr, c : String;
Begin
inherited Create;
Sorted := true;
i := R.ReadInteger;
While i > 0 do
  begin
  dec(i);
  FIrr := R.ReadString;
  //  supprimer sitt la conversion faite.
  if Firr[length(Firr)] in ['0'..'9'] then
    system.delete(Firr, length(Firr), 1);
  iliste := R.ReadInteger;
  While iliste > 0 do
      begin
      c := R.ReadString;
      f := R.ReadInteger;
      Ajoute(Firr, c, f, R.ReadInteger);
      dec(iliste);
      end;
  end;
end;

Procedure TListeIrreg.Ecris(W : TWriter);
var i, j : integer;
Begin
W.WriteInteger(Count);
For i := 0 to count-1 do
  begin
  W.WriteString(Strings[i]);
  W.WriteInteger(Definitions(i).count);
  For j := 0 to Definitions(i).count-1 do With Definition(i, j) do
    Begin
    W.WriteString(Canon);
    W.WriteInteger(Flags);
    W.WriteInteger(Modele);
    end;
  end;
end;

Procedure TListeIrreg.Ajoute(C : String ; K : String; F, M : integer);
var p : integer;
Begin
if Find(C, p) then
  TList(Objects[p]).Add(TDonneesIrreg.Create(F, M, K))
  else
  Begin
  AddObject(C, TList.Create);
  Ajoute(C, K, F, M);
  end;
end;

Function TListeIrreg.Definitions(N : integer) : TList;
Begin
  Result := TList(Objects[N]);
end;


Function TListeIrreg.Definition(N, D : integer) : TDonneesIrreg;
Begin
Result := TDonneesIrreg(Definitions(N)[D]);
end;

Procedure TListeIrreg.IrregsK(K: string; L: TStrings);
var iIrr, IDef : integer;
begin
   // renvoie la liste des formes irrgulires du canon K
L.Clear;
for iIrr := 0 to count - 1
   do for iDef := 0 to Definitions(iIrr).Count - 1
      do if Definition(iIrr, iDef).Canon = K
      then L.Add(strings[iIrr] + ' : ' + Definition(iIrr, iDef).Graphie(false));
end;

procedure TListeIrreg.DeleteKF(K : string; F : integer);
var
   iIrr, iDef, N : integer;
   inuentum : boolean;
begin
N := 0;
inuentum := false;
for iIrr := 0 to count - 1 do
   begin
      for iDef := 0 to Definitions(iIrr).Count - 1
         do if Definition(iIrr, iDef).Canon = K then
             begin
                if N = F then
                   begin
                      Definitions(iIrr).Delete(iDef);
                      if Definitions(iIrr).Count = 0 then
                         begin
                            delete(iIrr);
                            inuentum := true;
                            break;
                         end;
                   end;
                inc(N);
             end;
      if inuentum
         then break;
   end;
end;

function TListeIrreg.DefKNum(K: string; Num: integer): TDonneesIrreg;
var
   iIrr, iDef, N : integer;
   inuentum : boolean;
begin
Result := nil;
N := 0;
inuentum := false;
for iIrr := 0 to count - 1 do
   begin
      for iDef := 0 to Definitions(iIrr).Count - 1
         do if Definition(iIrr, iDef).Canon = K then
             begin
                if N = Num then
                   begin
                      inuentum := true;
                      result := Definition(iIrr, iDef);
                      break;
                   end;
                inc(N);
             end;
      if inuentum
         then break;
   end;
end;

function TListeIrreg.GraphieFNum(K: string; Num: integer): string;
var
   iIrr, iDef, N : integer;
   inuentum : boolean;
begin
Result := '';
N := 0;
inuentum := false;
for iIrr := 0 to count - 1 do
   begin
      for iDef := 0 to Definitions(iIrr).Count - 1
         do if Definition(iIrr, iDef).Canon = K then
             begin
                if N = Num then
                   begin
                      inuentum := true;
                      result := strings[iIrr];
                      break;
                   end;
                inc(N);
             end;
      if inuentum
         then break;
   end;
end;

end.
