unit UPrinc;

{Arcus - application d'aide  l'acquisition de la syntaxe latine.

Copyright (C) 2001 Y. Ouvrard.

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le
modifier conformment aux dispositions de la Licence Publique Gnrale GNU,
telle que publie par la Free Software Foundation ; version 2 de la licence,
ou encore ( votre choix) toute version ultrieure.
Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE
GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou D'ADAPTATION
A UN OBJET PARTICULIER.
Pour plus de dtail, voir la Licence Publique Gnrale GNU .
Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la
Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
Pour tout contact avec les auteurs : yves.ouvrard@collatinus.com}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, objets, Menus, Buttons, ToolWin, ComCtrls, ExtCtrls, OleCtrls,
  SHDocVw_TLB;

type
  TFPrinc = class(TForm)
    LabelP: TLabel;
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Quitter1: TMenuItem;
    PanelP: TPanel;
    BoutonAB: TSpeedButton;
    BoutonAD: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    LabelABAD: TLabel;
    Ouvrir1: TMenuItem;
    ComboLiens: TComboBox;
    ImageLiens: TImage;
    OpenDialog1: TOpenDialog;
    Aide1: TMenuItem;
    APropos1: TMenuItem;
    Sauver1: TMenuItem;
    PanelTexte: TPanel;
    BCorrection: TBitBtn;
    BPrec: TBitBtn;
    BSuiv: TBitBtn;
    ouvriruneanalyse1: TMenuItem;
    N1: TMenuItem;
    LabelCorr: TLabel;
    PanelEditeurs: TPanel;
    Splitter1: TSplitter;
    MemoTrav: TMemo;
    memoAide: TWebBrowser;
    Phrase1: TMenuItem;
    suivante1: TMenuItem;
    prcdente1: TMenuItem;
    grossir1: TMenuItem;
    rtrcir1: TMenuItem;
    procedure LabelPMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormActivate(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Ouvrir1Click(Sender: TObject);
    procedure APropos1Click(Sender: TObject);
    procedure Sauver1Click(Sender: TObject);
    procedure BSuivClick(Sender: TObject);
    procedure BPrecClick(Sender: TObject);
    procedure BCorrectionClick(Sender: TObject);
    procedure ouvriruneanalyse1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComboLiensChange(Sender: TObject);
    procedure grossir1Click(Sender: TObject);
    procedure rtrcir1Click(Sender: TObject);
  private
    { Dclarations prives }
    racine : string;
    topiques : TStringList;
    Haut_Etiq : integer;
    Texte : TTexte;
    TexteSol : TTexte;
    Phrase : TPhrase;
    IndexP : integer;
    MotClique : TMot;
    Ab, Ad : integer;
    Gab, Gad : string;
    FichierCorr : String;
    procedure mesureMots;
    function AbbrLien( E : string; rebours : boolean ) : String;
    procedure ArcS(Ab, Ad : TMot ; Edit : Boolean; Vis : Boolean);
    Procedure EffaceArcs;
    Procedure AffichePhrase;
    Procedure AfficheAbAd;
    procedure AfficheCorrection;
    Procedure Ouvre;
    Procedure OuvreEx(E : String);
    Procedure SauveTravEl;
  public
    { Dclarations publiques }
    passe : string;
    login : string;
  end;

var
  FPrinc: TFPrinc;

implementation

uses ULogin, qui, ULex, USyntaxe, hyperl;

{$R *.DFM}

var
   Eleve : TEleve;
   Groupe : TGroupe;

{ TFPrinc }

function TFPrinc.AbbrLien( E : string; rebours : Boolean ) : String;
// affecte le texte de l'tiquette ; reb donne le sens de la flche
   var
      debut : integer;
begin
  debut := succ(pos('(', E));
  result := Copy( E, debut, length(E) - debut);
  if rebours then result := '<' + result
     else result := result + '>';
end;

procedure TFPrinc.AffichePhrase;
   var i : integer;
begin
   Caption := format ('ARCVS - %s %d/%d', [Eleve.nom, succ(IndexP), Texte.count]); 
   LabelP.Caption := Phrase.texte;
   LabelP.Height := LabelP.Canvas.TextHeight('lp') + 4;
   // dimensionner la hauteur de l'image
   PanelEditeurs.Height := ClientHeight
      - ( LabelP.Canvas.TextWidth(Phrase.texte) div 3
      // - (Haut_Etiq * (Phrase.count div 2)
          + PanelTexte.Height
          + PanelP.Height
          + LabelP.Height);
   // effacer les arcs;
   EffaceArcs;
   for i := 0 to Phrase.count - 1 do
     if Phrase[i].LienS <> nil
         then Arcs(Phrase[i], Phrase[i].LienS, false, true);
end;

procedure TFPrinc.APropos1Click(Sender: TObject);
begin
   ShowMessage(
      'ARCVS - 1.0.1' + ret + 'Y.Ouvrard, Nov MMI' + ret
      + 'http://www.collatinus.com' + ret
      + 'licence GNU/GPL' + ret
      + 'yves.ouvrard@collatinus.com');
end;

Procedure TFPrinc.ArcS(Ab, Ad : TMot ; Edit : Boolean; Vis : Boolean);
   var H : integer;
       Gauche, Droite : integer;
       rebours : boolean;
       GT : integer;
       Abr : string;
begin
   rebours := Ab.O > Ad.O;
   if rebours then
      begin
         Gauche := Ad.O;
         Droite := Ab.O;
      end
      else
      begin
         Gauche := Ab.O;
         Droite := Ad.O;
      end;
   // H := (Haut_Etiq * succ(abs(Phrase.indexOf(Ab) - Phrase.IndexOf(Ad)) div 2));
   H := (Droite - Gauche) div 3;
   If Vis then ImageLiens.Canvas.Pen.Color := clRed
      Else ImageLiens.Canvas.Pen.Color := clWhite;
   ImageLiens.Canvas.Arc(
      Droite, -H,
      Gauche, H,
      Gauche, 0,
      Droite, 0);
   // activer l'tiquette
   if Edit
      then Ab.fonction := ComboLiens.Text;
   Abr := AbbrLien(Ab.fonction, rebours);
   // coordonnes de l'tiquette
   GT := Gauche + ((Droite - Gauche - ImageLiens.Canvas.TextWidth(Abr)) div 2) ;
   ImageLiens.Canvas.TextOut( GT, H, Abr);
end;

procedure TFPrinc.EffaceArcs;
begin
   // fond de la zone des arcs
   with ImageLiens.Canvas do
      begin
         brush.color := clWhite;
         fillrect(getClientRect);
      end;
end;

procedure TFPrinc.FormActivate(Sender: TObject);
begin

// vrif. de Login;
   racine := extractFilePath(paramstr(0));
   Topiques := TStringList.Create;
   Topiques.LoadFromFile(racine + 'html\index.txt');
   Eleve := Eleves.EleveParPasse(passe);
   if Eleve = nil then
      begin
         ShowMessage('Nom inconnu.');
         Close;
      end;
   Groupe := Groupes.GrParNom (Eleve.groupe);

   // charger le lexique
   LisLexique(CheminLex + 'collatinus.lex');

   // agrandir : TForm
   ImageLiens.align := alClient;
   LabelCorr.Caption := '';
   with ComboLiens do
      begin
         Items.Text := fonctions;
         DropDownCount := Items.count;
         ItemIndex := 0;
      end;


   // dimensionner les diteurs
   MemoAide.Width := Width div 2;
   MemoTrav.align := alClient;

   // hauteur d'tiquette
   Haut_Etiq := ImageLiens.Canvas.TextHeight(lettres);

   // Titre de la Forme
   Caption := 'ARCVS - ' + Eleve.nom;

   // Nom de l'lve dans le mmo de l'lve
   MemoTrav.Text := Eleve.nom;

   // affichage des menus et boutons selon les droits du groupe :
   Ouvrir1.Visible := Eleve.admin;
   Sauver1.Visible := Eleve.admin;
   ouvriruneanalyse1.Visible := Ouvrir1.Visible;
   BCorrection.Visible := Groupe.droit_correction and not Eleve.admin;
   if not (Groupe.droit_lexique or Groupe.droit_morpho) then
      begin
         MemoAide.width := 0;
         Splitter1.Visible := false;
      end;

   // dialogues
   OpenDialog1.InitialDir := racine + 'exx';

   // initialisation des variables d'arc
   BoutonAB.Down := True;

   // ouvrir l'exercice
   // 1. administrateur
   if Eleve.admin
      then OuvreEx(racine + 'corr\' + extractFileName(Groupe.exercice))
   // 2. lve : chercher un travail commenc : system
      else OuvreEx(Groupe.exercice);
end;

procedure TFPrinc.LabelPMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var i, iMorpho : integer;
      ma : integer; // variable d'affichage voc/morpho
      AideVoc : TStringList;
      Analyses : TListeAnalyses;
      inuentum : Boolean;
      LH : TStringList;
      LT : String;
begin
   // traitement du clic : sur quel mot ?
   if Button = mbRight
      then exit;
   for i := 0 to Phrase.Count - 1 do
      if Phrase[i].D > X then
         begin
            MotClique := Phrase[i];
            break;
         end;
   // affichage AbAd :
   if BoutonAb.Down then
      begin
         Ab := i;
         Gab := Phrase[i].Graphie;
      end
      else
      begin
         Ad := i;
         Gad := Phrase[i].Graphie;
      end;
   AfficheAbAd;
   if BoutonAb.Down
      then BoutonAd.Down := true;
   // vocabulaire, morphologie
   if Groupe.Droit_Lexique then
      begin
         if Groupe.Droit_Morpho
            then ma := maAnalyses
            else ma := maVocSeul;
         AideVoc := AnalysesDe(trim(Phrase[i].Graphie), inuentum, ma);
         LH := TStringList.Create;
         LH.text := Hyperlie(Eleve.nom, AideVoc.Text, topiques);
         LH.SaveToFile(racine + 'html\' + Eleve.nom + '.html');
         MemoAide.Navigate(racine + 'html\' + Eleve.nom + '.html',
            emptyparam, emptyparam, emptyparam, emptyparam);
         LH.Free;
         AideVoc.Free;
      end
      else if Groupe.Droit_Morpho then
      begin
         Analyses := ListeAnalysesDe(trim(Phrase[i].Graphie), inuentum);
         LH := TStringList.Create;
         For i := 0 to Analyses.count - 1
            do for iMorpho := 0 to Analyses.analyse(i).numeros.count - 1 do
                  LT := LT + Analyses.analyse(i).numeros.graphie(iMorpho) + ret;
         LH.Text := Hyperlie(Eleve.nom, LT, topiques);
         LH.SaveToFile(racine + 'html\' + Eleve.nom + '.html');
         MemoAide.Navigate(racine + 'html\' + Eleve.nom + '.html',
            emptyparam, emptyparam, emptyparam, emptyparam);
         LH.Free;
      end;
end;

procedure TFPrinc.Ouvrir1Click(Sender: TObject);
begin
   Ouvre;
end;

procedure TFPrinc.Quitter1Click(Sender: TObject);
begin
   Close;
end;

procedure TFPrinc.Sauver1Click(Sender: TObject);
   var F : TextFile;
begin
   // administrateur enregistrer le travail
   // 1. s'il s'agit d'une premire analyse
   // 2. si c'est l'dition d'une analyse
   AssignFile(F, FichierCorr);
   Rewrite(F);
   Writeln(F,Texte.ChaineXML);
   CloseFile(F);
end;

procedure TFPrinc.SpeedButton1Click(Sender: TObject);
begin
   // trace l'arc
   if (Ab >= 0) and (Ad >= 0) then
      begin
         Phrase[Ab].LienS := Phrase[Ad];
         Phrase[Ab].Fonction := ComboLiens.Text;
         // trace l'arc et l'tiquette
         // ArcS(Phrase[Ab], Phrase[Ad], true, True);
         AffichePhrase;
         BoutonAB.down := true;
      end;
end;

procedure TFPrinc.SpeedButton2Click(Sender: TObject);
begin
  if (Ab >= 0) and (Ad >= 0) then
     begin
        Phrase[Ab].LienS := Nil;
        Phrase[Ab].fonction := '';
        // ArcS(Phrase[Ab], Phrase[Ad], true, False);
        AffichePhrase;
     end;
end;

procedure TFPrinc.BSuivClick(Sender: TObject);
begin
   // phrase suivante :  rgler suivant les options de groupe.
   if (Phrase <> nil) and (indexP < Texte.count - 1) then
      begin
         // enregistrer le travail
         if not Eleve.Admin
            then SauveTravEl;
         // charger la phrase;
         inc(indexP);
         Phrase := Texte[indexP];
         mesureMots;
         affichePhrase;
         if not Eleve.admin and Groupe.droit_correction
            then afficheCorrection;
      end;
end;

procedure TFPrinc.BPrecClick(Sender: TObject);
begin
   // prase prcdente
   if (Phrase <> nil) and ( indexP > 0 ) then                 
      begin
         dec(indexP);
         Phrase := Texte[indexP];
         mesureMots;
         affichePhrase;
         if not Eleve.admin and Groupe.droit_correction
            then afficheCorrection;
      end; 
end;

procedure TFPrinc.BCorrectionClick(Sender: TObject);
begin
   // correction : du texte ? de la phrase ? suivant les options du groupe ?
   if TexteSol <> nil
      then Phrase.Corrige(TexteSol[indexP]);
   if (Phrase.points = TexteSol[indexP].points)
      and (indexP < Texte.count - 1)
      and (MessageDlg(
         'Tous les arcs ont t trouvs. Phrase suivante ?',
          mtConfirmation, [mbYes, mbNo], 0) = mrYes)
      then BSuivClick(nil);
   AffichePhrase;
   AfficheCorrection;
end;

procedure TFPrinc.mesureMots;
  var i, iMot : integer;
      enMot : boolean;
      gauche, DecO, largeur : integer;
begin
   // calcule tous les champs graphiques des mots de la phrase;
   if Phrase = nil then exit;
   iMot := 0;
   i := 1;
   while pos(Phrase.texte[i], lettres) = 0
      do inc(i);
   enMot := true;
   largeur := LabelP.Canvas.TextWidth(copy(Phrase.texte, 1, i));
   while i <= length(Phrase.texte) do
      begin
         if (Pos(Phrase.texte[i], lettres) = 0) and enMot then
            begin
               enMot := False;
               Gauche := Largeur;
               // Largeur := ImageLiens.Canvas.TextWidth(
               Largeur := LabelP.Canvas.TextWidth(
                  copy(Phrase.texte, 1, i));
               // DecO := ImageLiens.Canvas.TextWidth(Phrase[iMot].Graphie) div 2;
               DecO := LabelP.Canvas.TextWidth(Phrase[iMot].Graphie) div 2;
               with Phrase[iMot] do
                  begin
                     G := gauche;
                     O := Gauche + DecO;
                     D := Largeur
                  end;
               inc(iMot);
            end
            else enMot := true;
      inc(i);
   end;
end;

procedure TFPrinc.Ouvre;    
   var Liste : TStringList;
begin
with OpenDialog1 do
   if Execute then
      begin
         Texte.free ;
         indexP := 0;
      // ouvrir un texte (provisoirement une phrase)
         Liste := TStringList.Create;
         Liste.LoadFromFile(OpenDialog1.FileName);
         Texte := TTexte.Lis(Liste);
         Liste.Free;
         //phrase := TPhrase.Lis(Liste);
         Phrase := Texte[indexP];

         // afficher la nouvelle phrase.
         MesureMots;
         AffichePhrase;
         // prparer l'enregistrement de la Solution
         FichierCorr := racine + 'corr\'
            + ExtractFileName(OpenDialog1.FileName);
      end;
end;

procedure TFPrinc.ouvriruneanalyse1Click(Sender: TObject);
begin
  OpenDialog1.InitialDir := racine + 'trav\';
  Ouvre;
end;

procedure TFPrinc.OuvreEx(E: String);
   var Liste : TStringList;
       FEl : String;
begin
   Texte.Free ;
   indexP := 0;
   Liste := TStringList.Create;
   // ouvrir ventuellement les analyses commences
   FEl := racine + 'trav\' + Eleve.nom + '.xml';
   if FileExists(FEl)
      then Liste.LoadFromFile(FEl)
      else Liste.LoadFromFile(E);
   Texte := TTexte.Lis(Liste);
   Liste.Free;

   // rcuprer le texte saisi lors de la session prcdente
   FEL := racine + 'trav\' + Eleve.nom + '.txt';
   if FileExists(FEl)
      then MemoTrav.Lines.LoadFromFile(FEl);

   // initialiser la phrase
   Phrase := Texte[indexP];
   // afficher la nouvelle phrase.
   MesureMots;
   AffichePhrase;
   // Prparer l'enregistrement
   FichierCorr := racine + 'corr\' + ExtractFileName(E);
   // si lve, tenter d'ouvrir le Texte solution
   if (not Eleve.admin) and (Groupe.droit_correction) then
      begin
         Liste := TStringList.Create;
         Liste.LoadFromFile(
            racine + 'corr\'
            + extractFileName(E));
         TexteSol := TTexte.Lis( Liste);
         Liste.Free;
      end;
end;

procedure TFPrinc.SauveTravEl;
var
   F : TextFile;
   NF : String;
begin
   // enregistre dans ../trav/ le travail de l'lve
   NF := racine + 'trav\' + Eleve.nom + '.xml';
   AssignFile(F, NF);
   Rewrite(F);
   Writeln(F,Texte.ChaineXML);
   CloseFile(F);
   // enregistrer le travail de traduction

   NF := racine + 'trav\' + Eleve.nom + '.txt';
   MemoTrav.Lines.SaveToFile(NF);  
end;

procedure TFPrinc.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   If (Eleve <> nil) and not Eleve.admin
      then SauveTravEl;
   Topiques.free;
end;

procedure TFPrinc.AfficheAbAd;
begin
   // met  jour le labelAbAd.
   LabelAbAd.Caption := format('%s > %s > %s', [Gab, ComboLiens.Text, Gad]);
end;

procedure TFPrinc.ComboLiensChange(Sender: TObject);
begin
   AfficheAbAd;
end;

procedure TFPrinc.AfficheCorrection;
begin
   // met  jour labelCorr.
   LabelCorr.Caption :=
         format('Arcs : %d / %d points',
            [Phrase.points, TexteSol[IndexP].points]);
end;

{
// extension possible : traduction.
procedure TFPrinc.memoAideBeforeNavigate2(Sender: TObject;
  const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
  var traduction : string;
begin
   if pos( 'tr-verbe', URL ) > 0 then
      begin
        traduction :=  verbe ( MotClique.Graphie ) ;
        sm.FileWrite ( racine + 'html\' + Eleve.nom + '.html', traduction );
        memoAide.Navigate ( racine + 'html\' + Eleve.nom + '.html',
            emptyparam, emptyparam, emptyparam, emptyparam);
      end;
end;
}

procedure TFPrinc.grossir1Click(Sender: TObject);
begin
   with LabelP.Font do
      if Size < 20 then
         begin
            Size := Size + 2;
            LabelP.Refresh;
            MesureMots;
            AffichePhrase;
         end;
end;

procedure TFPrinc.rtrcir1Click(Sender: TObject);
begin        
   with LabelP.Font do
      if Size > 6 then
         begin
            Size := Size - 2;
            LabelP.Refresh;
            MesureMots;
            AffichePhrase;
         end;
end;

end.
