unit USyntaxe;
{Collatinus - Extraction du lexique d'un texte latin.

Copyright (C) 1998 Y. Ouvrard.

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le
modifier conformment aux dispositions de la Licence Publique Gnrale GNU,
telle que publie par la Free Software Foundation ; version 2 de la licence,
ou encore ( votre choix) toute version ultrieure.
Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE
GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou D'ADAPTATION
A UN OBJET PARTICULIER.
Pour plus de dtail, voir la Licence Publique Gnrale GNU .
Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la
Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
Pour tout contact avec les auteurs : yves.ouvrard@collatinus.com}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, UMorpho, UDes, ULex, UIrreg, Utiles, StdCtrls, ComCtrls;

type

  TLienSyntaxique = Class
     dependant : TListeAnalyses;
     tete : TListeAnalyses;
     resultats : TStringList;
     constructor Create ( D, T : string );
     destructor Destroy; override;
     end;

// function prepabl ( p : string ) : boolean;
// function prepacc ( p : string ) : boolean;

implementation

uses UListes;

function EstUn( m : string; liste : string ) : boolean;
begin
  result := pos( format(',%s,', [m]), liste) > 0;
end;

{ TLienSyntaxique }

constructor TLienSyntaxique.Create(D, T: string);
   const                         
     rAblAbs = '%s %s, ablatif absolu';
     rAblatif = '%s complment de cause, manire, moyen, temps, etc. du verbe %s';
     rApp = '%s appos au nom %s';
     rAttrS = '%s attribut du sujet du verbe %s';
     rCAdj = '%s complment au gnitif de l''adjectif %s';
     rCDN = '%s complment du nom %s';
     rCOD = '%s COD du verbe %s';
     rConjsub = 'la conj. %s introduit une prop. sub. dont %s est le verbe';
     rDatif = '%s complment au datif du verbe %s (COI ou COS)';
     rDet = '%s dterminant de %s';
     rEpith = 'l''adj. %s est pithte de %s';
     rInfCOD = '%s inf. COD du verbe %s, peut-tre verbe d''une prop. inf.';
     rPrepAbl = 'la prposition %s introduit l''ablatif %s';
     rPrepAcc = 'la prposition %s introduit l''accusatif %s';
     rSujet = '%s sujet du verbe %s';
     rSujetInf = '%s sujet d''une prop. inf. dont %s est le verbe';
   var inuentumD, inuentumT : boolean;
       iAnTete, iAnDep, iNumTete, iNumDep : integer;
       DefTete, DefDep : TDef;
       canonDep, canonTete : string;
begin
   resultats := TStringList.Create;
   resultats.Sorted := true;
   resultats.Duplicates := dupIgnore;
   // 1. analyser les deux membres.
   dependant := ListeAnalysesDe(D, inuentumD);
   tete := ListeAnalysesDe(T, inuentumT);
   // 2. traitement de l'chec
   if not inuentumD then
       resultats.Add( D + ' n''a pu tre analys');
   if not inuentumT then
         resultats.Add( T + ' n''a pu tre analys');
   // 3. boucles de morpho D et T
   // showMessage ( inttostr(dependant.Analyse(0).Numeros.Count ));
   if inuentumD and inuentumT
      then for iAntete := 0 to tete.Count - 1
        do for iNumTete := 0 to tete.Analyse(iAnTete).Numeros.Count - 1
          do for iAnDep := 0 to dependant.count - 1
             do for iNumDep := 0 to dependant.Analyse(iAnDep).Numeros.Count - 1 do
               begin
                  DefTete := tete.Analyse(iAnTete).Numero(iNumTete);
                  DefDep := dependant.Analyse(iAnDep).Numero(iNumDep);
                  CanonTete := PremierMot(tete.Analyse(iAnTete).canon);
                  CanonDep := PremierMot(dependant.Analyse(iAnDep).canon);
                  case DefDep.Categorie of
                     cNom, cPron :
                        begin
                        if (DefDep.Categorie = cPron)
                           and (EstUn(CanonDep, ListeD)
                                 and (DefTete.Casus = DefDep.Casus)
                                 and (DefTete.Numerus = DefDep.Numerus)
                                 and (DefTete.Genus = DefDep.Genus))
                                 then resultats.Add(
                                    format( rDet, [D, T]));
                        case DefTete.Categorie of
                           cNom, cPron:
                             begin
                             if DefDep.Casus = 3
                                then resultats.Add(
                                   format ( rCDN, [D, T]));
                             if (DefDep.Casus = DefTete.Casus)
                                and (DefDep.Numerus = DefTete.Numerus)
                                then resultats.Add(
                                   format( rApp, [D, T]));
                             end;
                           cVerbe:
                              begin
                              if (DefTete.Persona = 2)
                                 and (DefTete.Numerus = DefDep.Numerus)
                                 and (DefDep.Casus = 0) then
                                    begin
                                       resultats.Add(
                                          format ( rSujet, [D, T]));
                                       {attribut du sujet :
                                         pour les verbes attributifs
                                         liste hlas non exhaustive.
                                         }
                                       if (EstUn(canonTete, ListeVAttr))
                                       or ((EstUn(canonTete, ListeVPAttr))
                                          and (defTete.Vox = 1))
                                          then resultats.Add(
                                             format(rAttrS, [D, T]));
                                    end
                              else if (DefTete.Persona = 0)
                                 and (CanonDep = 'ego')
                                 then resultats.Add(format(rSujet, [D, T]))
                              else if (DefTete.Persona = 1)
                                 and (CanonDep = 'tu')
                                 then resultats.Add(format(rSujet, [D, T]))
                              else if DefDep.Casus = 2 then
                                 begin
                                   resultats.Add(format( rCOD, [D, T]));
                                   if (DefTete.Modus = 3)
                                     then resultats.Add(
                                        format( rSujetInf, [D, T]));
                                 end
                              else if (DefDep.Casus = 4)
                                 then resultats.Add(
                                    format( rDatif, [D, T]))
                              else if (DefDep.Casus = 5) then
                                 begin
                                    resultats.Add(
                                      format( rAblatif, [D, T]));
                                    if (DefTete.Modus = 4)
                                      and (DefTete.Casus = 5)
                                      and (DefTete.Numerus = DefDep.Numerus)
                                      then resultats.Add(
                                        format( rAblAbs, [D, T]));
                                 end;
                              end;
                           cAdj:
                              if ((DefDep.Casus = 3)
                                 and not (EstUn(canonTete, ListeAdjPoss)))
                                 then resultats.Add(
                                    format( rCAdj, [D, T]));
                           end;
                        end;
                     cAdj :
                        case DefTete.Categorie of
                           cNom, cPron: if (DefTete.Casus = defDep.Casus)
                              and (DefTete.Numerus = defTete.Numerus)
                              then resultats.Add(
                                 format( rEpith, [D, T]));
                           cVerbe : // attribut ?
                              begin 
                                // adjectifs indfinis de nombre
                                if (estUn(canonDep, ListeD))
                                   and (defDep.Casus = 0)
                                   and (defDep.Numerus = defTete.Numerus)
                                   then resultats.Add(
                                      format(rSujet, [D, T]));
                                 if (EstUn(canonTete, ListeVAttr))
                                       or ((EstUn(canonTete, ListeVPAttr))
                                          and (defTete.Vox = 1))
                                          then resultats.Add(
                                             format(rAttrS, [T, D]));
                              end;
                           end;
                     cVerbe :  // formes nominales et adjectivales.
                        case DefDep.Modus of
                           3 :  //infinitif
                              if (DefTete.Categorie = cverbe)
                                 then resultats.Add(
                                    format( rInfCOD, [D, T]));
                           4, 6 : // participe 
                              case DefTete.Categorie of
                                cNom, cPron : if (DefTete.Casus = defDep.Casus)
                                   and (DefTete.Numerus = defTete.Numerus)
                                   then resultats.Add(
                                      format( rEpith, [D, T]));
                              end;
                           end;
                     cInv :
                        begin
                           case DefTete.Categorie of
                              cNom, cPron:
                                 if (EstUn(D, ListePrepAbl))
                                    and (DefTete.Casus = 5)
                                    then resultats.Add(
                                       format( rPrepAbl, [D, T]))
                                 else if (EstUn(D, ListePrepAcc))
                                    and (DefTete.Casus = 2)
                                    then resultats.Add(
                                       format( rPrepAcc, [D, T]));
                              cVerbe:
                                 if (EstUn(D, ListeConjSub)) and (DefTete.Modus < 2)
                                    then resultats.Add(
                                       format( rConjSub, [D, T]));
                              end;
                        end;
                     end;
               end;
end;

destructor TLienSyntaxique.Destroy;
begin
   resultats.Free;
   dependant.Free;
   tete.Free;
end;

end.
