unit traduction;

interface

uses SysUtils, ULex, UMorpho, USyntaxe, UDes, FlexF;

function francais ( E : string ) : string;
function Verbe ( FL : string ) : string;

implementation

uses chaines;

function francais ( E : string ) : string;
begin
   result := trim ( copy ( E, pos(':', E) + 1, length(E)));
end;

function Corr_P ( P, N : integer ) : integer;
begin
   result := succ (P) + 3 * N ;
end;

function Corr_T ( T : integer ) : integer;
begin
   {  pour FlexF :
   pres = 1;
   fut = 2;
   impf = 3;
   psimple = 4;
   pcompose = 5;
   futant = 6;
   pqp = 7;
   pant = 8;

      pour Collatinus :
   ListeTemps : Array[0..5] of string = (
  'prsent',
  'futur',
  'imparfait',
  'parfait',
  'futur antrieur',
  'plus-que-parfait');
   }
   if T < 3
     then result := succ ( T )
     else result := T + 2;
end;

function corr_M ( M : integer ) : integer;
begin
{ind = 1;
   subj = 2;
   cond = 3;
   imper = 4;
   infin = 5;
   part = 6;
   ger = 7;}
 {
 ListeModes : Array[0..6] of string = (
  'indicatif',
  'subjonctif',
  'impratif',
  'infinitif',
  'participe',
  'grondif',
  'adjectif verbal');
 }
 case M of
    0, 1 : result := succ ( M );
    else result := M + 2;
    end;
end;

function LatFr ( A : TAnalyse ) : string;
   var inf : string;
       iNum : integer;
       num : TDef;
       P, T, M, V : integer;
       ligne : string;
begin
   result := '';
   inf := trim ( A.Canon );
   if  inf  = '?'
      then exit;
   inf := trim ( cut ( inf, 1, pos ( ':', inf ) + 1 ) );
   if IsFirst ('s''', inf )
      then inf := FirstWord ( inf ) + '''' + NthWord ( 2, inf )
   else if IsFirst ( 'se ', inf )
      then inf := FirstWord ( inf ) + ' ' + NthWord ( 2, inf )
   else inf := FirstWord ( inf );
   for iNum := 0 to A.Numeros.Count - 1 do
      begin
         num := A.Numero ( iNum );
         P := corr_P ( num.Persona, num.Numerus );
         T := corr_T ( num.Tempus );
         M := corr_M ( num.Modus );
         V := num.Vox + 1;
         ligne := FlexF.conjugue ( inf, P, T, M, V, true );
         if ligne > ''
            then result := result + ligne + ' ';
      end;
end;

function Verbe ( FL : string ) : string;
   var LA : TListeAnalyses;
       inventum : boolean;
       i : integer;
       ligne : string;
begin
   result := '';
   LA := ListeAnalysesDe ( FL, inventum );
   for i := 0 to LA.count - 1 do
      begin
         ligne := LatFr ( LA.Analyse ( i ) );
         if ligne > ''
            then result := result + ligne + ' ';
      end;
end;

end.
